# Code generated by Lark OpenAPI.

from typing import Optional

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.list_admin_user_stat_request import ListAdminUserStatRequest
from ..model.list_admin_user_stat_response import ListAdminUserStatResponse


class AdminUserStat(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def list(self, request: ListAdminUserStatRequest,
             option: Optional[RequestOption] = None) -> ListAdminUserStatResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListAdminUserStatResponse = JSON.unmarshal(str(resp.content, UTF_8), ListAdminUserStatResponse)
        response.raw = resp

        return response
