# Code generated by Lark OpenAPI.

from typing import Optional

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.reset_password_request import ResetPasswordRequest
from ..model.reset_password_response import ResetPasswordResponse


class Password(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def reset(self, request: ResetPasswordRequest, option: Optional[RequestOption] = None) -> ResetPasswordResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ResetPasswordResponse = JSON.unmarshal(str(resp.content, UTF_8), ResetPasswordResponse)
        response.raw = resp

        return response
