# Code generated by Lark OpenAPI.

from typing import Optional

from lark_oapi.core.enum import HttpMethod, AccessTokenType
from lark_oapi.core.model import BaseRequest


class GetOfferRequest(BaseRequest):
    def __init__(self) -> None:
        super().__init__()
        self.user_id_type: Optional[str] = None
        self.department_id_type: Optional[str] = None
        self.offer_id: Optional[str] = None

    @staticmethod
    def builder() -> "GetOfferRequestBuilder":
        return GetOfferRequestBuilder()


class GetOfferRequestBuilder(object):

    def __init__(self) -> None:
        get_offer_request = GetOfferRequest()
        get_offer_request.http_method = HttpMethod.GET
        get_offer_request.uri = "/open-apis/hire/v1/offers/:offer_id"
        get_offer_request.token_types = {AccessTokenType.TENANT}
        self._get_offer_request: GetOfferRequest = get_offer_request

    def user_id_type(self, user_id_type: str) -> "GetOfferRequestBuilder":
        self._get_offer_request.user_id_type = user_id_type
        self._get_offer_request.add_query("user_id_type", user_id_type)
        return self

    def department_id_type(self, department_id_type: str) -> "GetOfferRequestBuilder":
        self._get_offer_request.department_id_type = department_id_type
        self._get_offer_request.add_query("department_id_type", department_id_type)
        return self

    def offer_id(self, offer_id: str) -> "GetOfferRequestBuilder":
        self._get_offer_request.offer_id = offer_id
        self._get_offer_request.paths["offer_id"] = str(offer_id)
        return self

    def build(self) -> GetOfferRequest:
        return self._get_offer_request
