# Code generated by Lark OpenAPI.

from typing import Optional

from lark_oapi.core import JSON
from lark_oapi.core.const import UTF_8
from lark_oapi.core.http import Transport
from lark_oapi.core.model import Config, RequestOption, RawResponse
from lark_oapi.core.token import verify
from ..model.list_application_interview_request import ListApplicationInterviewRequest
from ..model.list_application_interview_response import ListApplicationInterviewResponse


class ApplicationInterview(object):
    def __init__(self, config: Config) -> None:
        self.config: Config = config

    def list(self, request: ListApplicationInterviewRequest,
             option: Optional[RequestOption] = None) -> ListApplicationInterviewResponse:
        if option is None:
            option = RequestOption()

        # 鉴权、获取token
        verify(self.config, request, option)

        # 发起请求
        resp: RawResponse = Transport.execute(self.config, request, option)

        # 反序列化
        response: ListApplicationInterviewResponse = JSON.unmarshal(str(resp.content, UTF_8),
                                                                    ListApplicationInterviewResponse)
        response.raw = resp

        return response
